// FAkerm.cpp: implementation of the FAkerm class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"
#include "FAkerm.h"
#include "FTskAkerm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CRcrsnApp theApp;
extern LArc TT_Akerm[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//	 
//	A(m,n):
//		A(0,n) = n+1 
//		A(m,0) = A(m-1, 1)
//		A(m,n) = A(m-1, A(m,n-1))
//	
//	A(m,n)=  
//		n+1,			m = 0 
//		A(m-1,1),		m != 0,	n = 0 
//		A(m-1,A(m,n-1)),m > 0,	n > 0 
FAkerm::FAkerm(int m, int n, TInfoAppl *pInf, int r)
	:FRcrsn(TT_Akerm, pInf, r)
{
	pInfo=pInf;
	if (!pInfo->pTskAkerm) {
		nRange=r;
	}
	nM = m; nN = n;	nF=0;
}

FAkerm::~FAkerm() {}
//	  
LArc TT_Akerm[] = {
/*
	//   
	LArc("st", "00", "x3x4",	"y13"),	//
	LArc("st", "a1", "^x3",		"y12"),	//
	LArc("st", "a1", "^x4",		"y12"),	//
	LArc("a1", "00", "x1",		"y11y6"),	//
	LArc("a1", "a1", "^x1x2",	"y10"),	//
	LArc("a1", "a2", "^x1^x2",	"y8"),	//
	LArc("a2", "a1", "--",		"y9"),	//
*/
//*
	LArc("st", "00", "x3x4",	"y13y6"),	//
	LArc("st", "f1", "^x3",		"--"),	//
	LArc("st", "f1", "^x4",		"--"),	//
	LArc("f1", "00", "x1",		"y1y6y7"),	//
	LArc("f1", "f2", "^x1x2",	"y2"),	//
	LArc("f1", "f3", "^x1^x2",	"y3"),	//
	LArc("f2", "00", "--",		"y5y6y7"),	//
	LArc("f3", "f2", "--",		"y4"),	//
//*/
/*
	//	    
	LArc("st", "00", "x3x4",	"y13"),	//
	LArc("st", "f1", "^x3",		"y12"),	//
	LArc("st", "f1", "^x4",		"y12"),	//
	LArc("f1", "00", "x1",		"y1"),	//
	LArc("f1", "f2", "^x1x2",	"y2"),	//
	LArc("f1", "f3", "^x1^x2",	"y3"),	//
	LArc("f2", "00", "--",		"y5"),	//
	LArc("f3", "f2", "--",		"y4"),	//
*/
	LArc()
	};
//	-----------                    
int FAkerm::x1() { return nM==0; }
int FAkerm::x2() { return nN==0; }
// "" ?
int FAkerm::x3() { return pInfo->pTskAkerm->bIfMemo; }		
//       ?
int FAkerm::x4() { return pInfo->pTskAkerm->arr[nM][nN]; }	
//	-----------                    
void FAkerm::y1() { 
	nF = nN+1; 
	if (x3()) {
		if (nM>(5-1)||nN>(2000000-1)) {
			int n =0;
		}
		pInfo->pTskAkerm->arr[nM][nN]=nF;
	}
}
void FAkerm::y2() { 
	CallAkerman(nM-1, 1, pInfo, pInfo->pTskAkerm->IncRange()); 
}
void FAkerm::y3() { 
	CallAkerman(nM, nN-1, pInfo, pInfo->pTskAkerm->IncRange()); 
}
void FAkerm::y4() { 
	int nPrev = PrevAkerman();
	CallAkerman(nM-1, nPrev, pInfo, pInfo->pTskAkerm->IncRange()); 
}
void FAkerm::y5() { 
	nF = PrevAkerman(); 
	if (x3()) {
		if (nM>(5-1)||nN>(2000000-1)) {
			int n =0;
		}
		pInfo->pTskAkerm->arr[nM][nN]=nF;
	}
}
void FAkerm::y6() { pInfo->pTskAkerm->DecRange(); }
void FAkerm::y7() { 
	if (((CRcrsnView*)pInfo->pOutWnd)->m_bViewStateAkerm) {
		((CRcrsnView*)pInfo->pOutWnd)->ViewValueAkerm(nF); 
	}

}
void FAkerm::y8() { 
	CallAkerman(nM, nN-1, pInfo, pInfo->pTskAkerm->IncRange());
}
void FAkerm::y9() { 
	nN = PrevAkerman();
	nM--;
}
void FAkerm::y10() { 
	nM--;
	nN = 1;
}
void FAkerm::y11() { 
	nF = nN+1;
	if (x3) {
		pInfo->pTskAkerm->arr[nM][nN]=nF;
	}
//	pInfo->pTskAkerm->arr[nM+1][nN] = nF; 
//	y7();
	int r = pInfo->pTskAkerm->pAppl->nRange;
}

void FAkerm::y12() { 
	int m=nM;
	int n = nN;
	int r = pInfo->pTskAkerm->pAppl->nRange;
}

void FAkerm::y13() { 
	nF = pInfo->pTskAkerm->arr[nM][nN];
}

int Akerman (TInfoAppl *pInf, int m, int n) 
{
	int nF;
	if (m==0) return n+1;
	if (n==0) {
		nF= Akerman(pInf, m-1,1);
//		((CRcrsnView*)pInf->pOutWnd)->ViewValueAkerm(nF);	
		return nF;
	}
	if (m && n) {
		nF= Akerman(pInf, m-1, Akerman(pInf, m,n-1));
//		((CRcrsnView*)pInf->pOutWnd)->ViewValueAkerm(nF);	
		return nF;
	}
}

int Akerman_2 (TInfoAppl *pInf, int m, int n) 
{
	while (m!=0) {
		if (n==0) {
			--m;
			n=1;
		}
		else {
			n= Akerman_2(pInf, m,n-1);
			--m;
//			((CRcrsnView*)pInf->pOutWnd)->ViewValueAkerm(n);	
		}
	}
	return n+1;
}

//int arrr[5][200000];
int arrr[5][2000];
void ClearAkkerman() {
	for (int i=0;i<5;i++) {
//		for (int j=0; j<200000; j++) {
		for (int j=0; j<2000; j++) {
			arrr[i][j]=0;
		}
	}
}

int Akerman_3 (TInfoAppl *pInf, int m, int n) 
{
	if (arrr[m][n]) {
		return arrr[m][n];
	}
	else {
		int nF;
		if (m==0) {
			arrr[m][n]=n+1;
			return n+1;
		}
		if (m!=0&&n==0) {
			nF= Akerman_3(pInf, m-1,1);
		}
		else if (m && n) {
			nF= Akerman_3(pInf, m-1, Akerman_3(pInf, m,n-1));
		}
		arrr[m][n]=nF;
		return nF;
	}
}

int Akerman_4 (int m, int n) 
{
	if (arrr[m][n]) {
		return arrr[m][n];
	}
	else {
		int nF;
		if (m==0) {
			arrr[m][n]=n+1;
			return n+1;
		}
		if (m!=0&&n==0) {
			nF= Akerman_4(m-1,1);
		}
		else if (m && n) {
			nF= Akerman_4(m-1, Akerman_4(m,n-1));
		}
		arrr[m][n]=nF;
		return nF;
	}
}
