// FHanoy.cpp: implementation of the FHanoy class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"
#include "FHanoy.h"
#include "FTskHanoy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern LArc TT_Hanoy[];
extern LArc TT_Hanoy_Leg[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//	k -  ()  
//	a -   
//	b -   
FHanoy::FHanoy(int k, int a, int b, TInfoAppl *pInf, int r)
//	:FRcrsn(TT_Hanoy, pInf, r)
	:FRcrsn(TT_Hanoy_Leg, pInf, r)
{
	pInfo=pInf;
	nK=k; nA=a; nB=b; pHanoy = NULL; nRange = r;
	if (!pInfo->pTskHanoy) {
		nRange=r;
	}
}

FHanoy::~FHanoy() {	if (pHanoy) delete pHanoy; }

LArc TT_Hanoy[] = {
	LArc("h1", "h2", "x1",		"y1"),	//
	LArc("h1", "00", "^x1",		"y3"),	//
	LArc("h2", "00", "--",		"y2y3"),	//
	LArc()
	};

int FHanoy::x1() { return nK>=1; }

void FHanoy::y1() {	CallHanoy(nK-1, nA, 6-nA-nB, pInfo, pInfo->pTskHanoy->IncRange()); }

void FHanoy::y2() { 
	Move();	
	CallHanoy(nK-1, 6-nA-nB, nB, pInfo, pInfo->pTskHanoy->IncRange());
}

void FHanoy::y3() { 
	pInfo->pTskHanoy->DecRange();
}

LArc TT_Hanoy_Leg[] = {
	LArc("h1", "h2", "--",		"y4"),	//
	LArc("h2", "h3", "x2",		"y6"),	//
	LArc("h2", "00", "^x2",		"--"),	//
	LArc("h3", "h4", "--",		"y7y8"),	//
	LArc("h4", "h5", "--",		"y10y11"),	//
	LArc("h5", "h6", "--",		"y9"),	//
	LArc("h6", "h2", "--",		"y5"),	//
	LArc()
	};

int FHanoy::x2() { return i <= steps; }

unsigned DiskNumber(unsigned i);
unsigned Shifts(unsigned i, unsigned disk_number);
unsigned Delta(unsigned disks, unsigned disk_number);
unsigned Src(unsigned shifts, unsigned delta);
unsigned Rec(unsigned shifts, unsigned delta);

void FHanoy::y4() { 
	disks = nK;
	steps = (1 << (disks)) - 1; i= 1; 
}
void FHanoy::y5() { i++; }
void FHanoy::y6() { nK = disk_number = DiskNumber(i); }
void FHanoy::y7() { shifts = Shifts(i, disk_number); }
void FHanoy::y8() { delta = Delta(disks, disk_number); }
void FHanoy::y9() { Move(); }
void FHanoy::y10() { nA = Src(shifts, delta); nA++; }
void FHanoy::y11() { nB = Rec(shifts, delta); nB++; }

void FHanoy::Move() { 
	((CRcrsnView*)pInfo->pOutWnd)->MoveHanoy(nK, nA, nB);	
}

// void hanoy(int k, int a, b)
//        ,  
// hanoy(3, 1, 2)	
void move (int k, int a, int b);
void hanoy(int k, int a, int b)
{
	if (k>=1) {
		hanoy(k-1, a, 6-a-b);
		move (k, a, b);
		hanoy(k-1, 6-a-b, b);
	}
	return;
}

void move (int k, int a, int b)
{
}


/*
void move(int i, int j, int d);

void hanoy(int i, int j, int k, int d)
{
	int m ;
	for (m = 0; m < d; m++) printf(" ");
	printf("hanoy(%d,%d,%d)\n", i, j, k);
	if (k == 1)
		move(i, j, d);
	else {
		hanoy(i, 6-i-j, k-1, d+1);
		hanoy(i, j, 1, d+1);
		hanoy(6-i-j, j, k-1, d+1);
	}
}

void move(int i, int j, int d)
{
	int m;
	for(m = 0; m < d; m++) printf(" ");
	printf("move(%d,%d)\n", i, j);
}

void main()
{
	int input = 3;
	printf("\n  %d :\n", input);
	hanoy(1, 3, input, 0);
}
*/
//    
//    0  2,  -  1  N.
//      0   2
//     , 
//        

//       
//        
// . ..,    .
unsigned DiskNumber(unsigned i)
{
	unsigned disk_number = 1;
	while(!(i & 1)) 
	{
		i >>= 1;
		++disk_number;
	}
	return disk_number;
}


//      
unsigned Shifts(unsigned i, unsigned disk_number)
{
	return (i >> disk_number) + 1;
}

//   . 
//     2. ,  1
unsigned Delta(unsigned disks, unsigned disk_number)
{
	unsigned odd = disks & 1; //   
	return 2 - (odd ^ (disk_number & 1));
}

//   
unsigned Src(unsigned shifts, unsigned delta)
{
	return (delta * (shifts - 1)) % 3;
}

//   
unsigned Rec(unsigned shifts, unsigned delta)
{
	return (delta * shifts) % 3;
}

/*
// ,    
void hanoy(unsigned disks)
{
	unsigned steps = (1 << (disks)) - 1;

	for(unsigned i = 1; i <= steps; i++)
	{
		//    
		unsigned disk_number = DiskNumber(i);
		//      
		unsigned shifts = Shifts(i, disk_number);
		//   . 
		unsigned delta = Delta(disks, disk_number);
		out(i, Src(shifts, delta), Rec(shifts, delta));
	}

	cout << endl << "Used " << disks << " disks. " 
		 << endl << "Make " << steps << " steps." 
		 << endl;
}
*/