// TInfoAppl.cpp: implementation of the TInfoAppl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Rcrsn.h"
#include "TInfoAppl.h"
#include "MainFrm.h"	// Added by ClassView
#include "Views\FViewFact.h"
#include "RcrsnDoc.h"
#include "RcrsnView.h"

#include "Turing\FTuring.h"
#include "Factorial\FTskFact.h"
#include "Akerman\FTskAkerm.h"
#include "Hanoy\FTskHanoy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CRcrsnApp theApp;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TInfoAppl::TInfoAppl(CMainFrame* pParent)
{
	pMW = pParent;						
	nTimeProc1	= 100000;
	nTimeProc2	= 5000;
	nTimeProc3	= 5000;

	pTuring = NULL;
	pTskFact = NULL;
	pTskAkerm = NULL;
	pTskHanoy = NULL;

	bIfAkerm	=	true;
	bIfHanoy	=	false;
	bIfFact		=	false;
}

TInfoAppl::~TInfoAppl()
{
	DeleteProcesses();
}

CArchive& operator<<(CArchive& ar, TInfoAppl &Dat)
{
	ar<<Dat.nTimeProc1;//	
	ar<<Dat.nTimeProc2;//	
	ar<<Dat.nTimeProc3;//	
	return ar;
}

CArchive& operator>>(CArchive& ar, TInfoAppl &Dat)
{
	ar>>Dat.nTimeProc1;
	ar>>Dat.nTimeProc2;
	ar>>Dat.nTimeProc3;
	return ar;
}

void TInfoAppl::LoadProcesses()
{
	DeleteProcesses();
	TNetFsa	*pNet;		

	pNet = theApp.pNetFsa;
	pTuring = new FTuring();
	pTuring->FLoad(pNet,1);
	pNet->go_task();

//------ 
	if (bIfFact) {
		pNet = theApp.pNetFsa;
		if (((CRcrsnView*)pOutWnd)->m_nThreadFact==2) {
			pNet = theApp.pNetFsa1;
		}
		else if (((CRcrsnView*)pOutWnd)->m_nThreadFact==3) {
			pNet = theApp.pNetFsa2;
		}
		pTskFact = new FTskFact(this, pNet);
		pTskFact->FLoad(pNet,1);
		pNet->go_task();
	}
//------  
	if (bIfHanoy) {
		pNet = theApp.pNetFsa;
		if (((CRcrsnView*)pOutWnd)->m_nThreadHanoy==2) {
			pNet = theApp.pNetFsa1;
		}
		else if (((CRcrsnView*)pOutWnd)->m_nThreadHanoy==3) {
			pNet = theApp.pNetFsa2;
		}
		pTskHanoy = new FTskHanoy(this, pNet);
		pTskHanoy->FLoad(pNet,1);
		pNet->go_task();
	}
//------  
	if (bIfAkerm) {
		pNet = theApp.pNetFsa;
		if (((CRcrsnView*)pOutWnd)->m_nThreadAkerm==2) {
			pNet = theApp.pNetFsa1;
		}
		else if (((CRcrsnView*)pOutWnd)->m_nThreadAkerm==3) {
			pNet = theApp.pNetFsa2;
		}
		pTskAkerm = new FTskAkerm(this, pNet);
		pTskAkerm->FLoad(pNet,1);
		pNet->go_task();
	}
//------
}

void TInfoAppl::DeleteProcesses()
{
	if (pTuring) delete pTuring;
	pTuring = NULL;

	if (pTskFact) {
		if (!pTskFact->FIsActiveTask()) {
			delete pTskFact;
			pTskFact = NULL;
		}
		else {
			if (bIfHanoy) {
				delete pTskFact;
				pTskFact = NULL;
			}

		}
	}

	if (pTskHanoy)	{
		if (!pTskHanoy->FIsActiveTask()) {
			delete pTskHanoy;
			pTskHanoy = NULL;
		}
		else {
			if (bIfHanoy) {
				delete pTskHanoy;
				pTskHanoy = NULL;
			}

		}
	}

	if (pTskAkerm)	{
		if (!pTskAkerm->FIsActiveTask()) {
			delete pTskAkerm;
			pTskAkerm = NULL;
		}
		else {
			if (bIfAkerm) {
				delete pTskAkerm;
				pTskAkerm = NULL;
			}

		}
	}
}
